var BootstrapComponents = (function(){

	function BootstrapComponents(){};

	var renderComponent = function(compound, view, locals) {

		var fs = require('fs');
		var path = require('path');
	    var jade = require('jade');

	    var filename = path.resolve(__dirname, view);

	    var engine = jade.compile(fs.readFileSync(filename), {});

	    return engine(locals);

	};

	/*
	*  Bootstrap Typeahead component
	*/
	BootstrapComponents.prototype.typeahead = function(formName, controlId, dataUrl, selectedValue) {

	    var params = {
	      formName: formName,
	      controlId: controlId,
	      dataUrl: dataUrl,
	      selectedValue: selectedValue
	    };

	    return renderComponent(this.compound, 'component/typeahead.jade', params);
    
 	};

 	/*
	*  Bootstrap Typeahead component
	*/
	BootstrapComponents.prototype.datepicker = function(form, field) {

	    var params = {
	      form: form,
	      field: field
	    };

	    return renderComponent(this.compound, 'component/datepicker.jade', params);
    
 	};

 	

 	return BootstrapComponents;

})();


/*
* BindableComponents is a helper to attached components to an existing module.export
*/
function BindableComponents(){

}

BindableComponents.prototype = {
	BindToExports: function(exports) {

	    if (!exports) return;

	    var helper = BootstrapComponents.prototype;

        for (var method in helper) {
            if ('function' === typeof helper[method]) {
                exports[method] = helper[method];
            }
        }
	}
};

module.exports = BindableComponents.prototype;

