var ChosenComponents = (function(){

	function ChosenComponents(){};

	var renderComponent = function(compound, view, locals) {

		var fs = require('fs');
		var path = require('path');
	    var jade = require('jade');

	    var filename = path.resolve(__dirname, view);

	    var engine = jade.compile(fs.readFileSync(filename), {});

	    return engine(locals);

	};

	/*
	*  Chosen dropdown component
	*/
	ChosenComponents.prototype.chosen = function(controlId, controlName, data, selectedValue, options) {

		options = options || { no_results_text: "Oops, nothing found!", placeholder_text_single: "Select an option", disable_search_threshold: 10};		

		var dataUrl = (typeof data === 'string') ? data : null;
		data = (typeof data === 'string') ? null : data;

	    var params = {	      
	      controlId: controlId,
	      controlName: controlName,
	      data: data,
	      dataUrl: dataUrl,
	      selectedValue: selectedValue,
	      options: JSON.stringify(options)
	    };

	    return renderComponent(this.compound, 'component/chosen.jade', params);
    
 	};

 	

 	return ChosenComponents;

})();


/*
* BindableComponents is a helper to attached components to an existing module.export
*/
function BindableComponents(){

}

BindableComponents.prototype = {
	BindToExports: function(exports) {

	    if (!exports) return;

	    var helper = ChosenComponents.prototype;

        for (var method in helper) {
            if ('function' === typeof helper[method]) {
                exports[method] = helper[method];
            }
        }
	}
};

module.exports = BindableComponents.prototype;

